# Interfaces Utilisateur Graphiques avec Tk

Tk/Tcl fait depuis longtemps partie intégrante de Python. Il fournit un jeu d'outils robustes et indépendants de la plateforme pour gérer des fenêtres. Disponible aux développeurs via le paquet `tkinter` et ses extensions, les modules `tkinter.tix` et `tkinter.ttk`.

Le paquet `tkinter` est une fine couche orientée objet au dessus de Tcl/Tk. Pour utiliser le module `tkinter`, vous n'avez pas à écrire de code Tcl, mais vous devrez consulter la documentation de Tk, et parfois la documentation de Tcl. Le module `tkinter` est un ensemble de surcouches implémentant les widgets Tk en classes Python. De plus, le module interne `_tkinter` fournit un mécanisme robuste permettant à des fils d'exécution Python et Tcl d'interagir.

Les avantages de `tkinter` sont sa rapidité, et qu'il est généralement fourni nativement avec Python. Bien que sa documentation soit mauvaise, d'autres ressources existent : des références, tutoriels, livres, … Le module `tkinter` est aussi célèbre pour son aspect vieillot, cependant il à été grandement amélioré depuis Tk 8.5. Néanmoins, il existe bien d'autres bibliothèques d'interfaces graphiques qui pourraient vous intéresser. Pour plus d'informations sur les alternatives, consultez le chapitre Autres paquets d'interface graphique utilisateur.

- `tkinter` — Interface Python pour Tcl/Tk
  - Modules Tkinter
  - Guide de survie Tkinter
    - Mode d'emploi
    - Un simple programme Hello World
  - Un (très) rapide aperçu de Tcl/Tk
  - Correspondance entre Basic Tk et Tkinter
  - Relations entre Tk et Tkinter
  - Guide pratique
    - Définition des options
    - L'empaqueteur
    - Options de l'empaqueteur
    - Association des variables de l'objet graphique
    - Le gestionnaire de fenêtres
    - Types de données des options Tk
    - Liaisons et événements
    - Le paramètre index
    - Images
  - Gestionnaires de fichiers
- `tkinter.ttk` --- Tk themed widgets
  - Using Ttk
  - Ttk Widgets
  - Widget
    - Standard Options
    - Scrollable Widget Options
    - Label Options
    - Compatibility Options
    - Widget States
    - ttk.Widget
  - Combobox
    - Options
    - Virtual events
    - ttk.Combobox
  - Spinbox
    - Options
    - Virtual events
    - ttk.Spinbox
  - Notebook
    - Options
    - Tab Options
    - Tab Identifiers
    - Virtual Events
    - ttk.Notebook
  - Progressbar
    - Options
    - ttk.Progressbar
  - Separator
    - Options
  - Sizegrip
    - Platform-specific notes
    - Bugs
  - Treeview
    - Options
    - Item Options
    - Tag Options
    - Column Identifiers
    - Virtual Events
    - ttk.Treeview
  - Ttk Styling
    - Layouts
- `tkinter.tix` --- Extension widgets for Tk
  - Using Tix
  - Tix Widgets
    - Basic Widgets
    - File Selectors
    - Hierarchical ListBox
    - Tabular ListBox
    - Manager Widgets
    - Image Types
    - Miscellaneous Widgets
    - Form Geometry Manager
  - Tix Commands
- `tkinter.scrolledtext` — Gadget texte avec barre de défilement
- IDLE
  - Menus
    - Menu File (Console et Éditeur)
    - Menu Edit (console et éditeur)
    - Menu Format (fenêtre d'édition uniquement)
    - Menu Run (fenêtre d'édition uniquement)
    - Menu Shell (fenêtre de console uniquement)
    - Menu Debug (fenêtre de console uniquement)
    - Menu Options (console et éditeur)
    - Menu Windows (console et éditeur)
    - Menu Help (console et éditeur)
    - Menus Contextuels
  - Édition et navigation
    - Fenêtre d'édition
    - Raccourcis clavier
    - Indentation automatique
    - Complétions
    - Info-bulles
    - Contexte du code
    - Fenêtre de console Python
    - Coloration du texte
  - Démarrage et exécution du code
    - Utilisation de la ligne de commande
    - Échec au démarrage
    - Exécuter le code de l'utilisateur
    - Sortie de l'utilisateur sur la console
    - Développer des applications tkinter
    - Exécution sans sous-processus
  - Aide et préférences
    - Sources d'aide
    - Modifier les préférences
    - IDLE sous macOS
    - Extensions
- Autres paquets d'interface graphique utilisateur